#ifndef LABEL_H
#define LABEL_H

#include <algorithm>

#include "geo.hpp"

class Label
{
public:
    Vector pos;
    double top, bottom, left, right;
    std::string text;
    double diag;

    Label():weight(1.0){
    }

    Label(const Vector& pos, double top, double bottom, double left, double right) :
        pos(pos), top(top), bottom(bottom), left(left), right(right) {
        update();
    }

    double weight;

    void update(){
        diag = std::sqrt( (left+right)* (left+right) + (top+bottom)* (top+bottom));
    }

    double get_max_diagonal() {
        double max_diag = std::hypot(right, top);
        max_diag = std::max(max_diag, std::hypot(right, top));
        max_diag = std::max(max_diag, std::hypot(left, top));
        max_diag = std::max(max_diag, std::hypot(right, bottom));
        return max_diag;
    }

};

#endif // LABEL_H
