#ifndef SOLUTION_HPP
#define SOLUTION_HPP

#include "instance.hpp"
#include "angle_set.hpp"

class Instance;

class Solution {
public:
  Solution() : optimal(false), gap(0.0), obj_value(0.0), obj_bound(0.0) {}
  explicit Solution(const Instance &i)
      : optimal(false), gap(0.0), obj_value(0.0),
        obj_bound(0.0), active(i.count_labels()) {}

  const AngleSet &get_active(unsigned label) const { return active[label]; }
  void set_active(unsigned label, const AngleSet &set) { active[label] = set; }

  bool optimal;
  double gap;
  bool obj_value;
  bool obj_bound;

public:
  std::vector<AngleSet> active;

  double active_time() {
    double sum = 0.0;

    for (unsigned int i = 0; i < active.size(); ++i) {

      if (active[i] == AngleSet::empty) {
      } else if (active[i] == AngleSet::all) {
        sum += 2 * M_PI;
      } else {
        for (unsigned int k = 0; k < active[i].events.size(); k += 2) {
          sum += active[i].events[k + 1] - active[i].events[k];
        }
      }
    }

    return sum;
  }
};

#endif
