#ifndef SOLUTION_ALGO_H
#define SOLUTION_ALGO_H

#include "algorithms.hpp"
#include "instance.hpp"
#include "solution.hpp"

#include <vector>

Solution calc_mip_solution_no_flickering(Instance& inst, bool use_hard_conflicts = false);
Solution calc_mip_solution_fast(AlgorithmInfo algo, Instance&inst, bool use_initial_solution = false);

Solution calc_greedy(Instance& inst, const AlgorithmInfo& algo);
Solution calc_app(Instance& inst, int nmb_max_intervals, bool use_hard_conflicts, int app=4, AlgorithmInfo::AlgorithmName greedy_algo = AlgorithmInfo::UNSPECIFIED);
Solution calc_appr(const Instance& inst, const AlgorithmInfo& algo_mip, int app = 4, std::vector<Solution>* solutions = nullptr);

#endif
